
/*ordering types used for sorting session lists*/
#define ALPHABETIC 1
#define STARTTIME 2

#define AUDIO 0
#define VIDEO 1
#define WHITEBOARD 2
#define TEXT 3

extern char *medianames[];

struct session {
  unsigned int aid;
  char *username;
  struct in_addr orighost;
  unsigned int sessid;
  unsigned int version;
  char *sname;
  char *desc;
  char *uri;
  int no_of_emails;
  struct lent *email;
  int no_of_phones;
  struct lent *phone;
  unsigned int starttime;
  unsigned int endtime;
  int no_of_times;
  struct tent *time;
  int no_of_attrs;
  struct lent *attr;
  int no_of_media;
  struct media *media;
};

struct lent {
  char *data;
  struct lent *next;
};

struct tent {
  unsigned int starttime;
  unsigned int endtime;
  struct tent *next;
};

struct media {
  struct in_addr addr;
  unsigned char ttl;
  char *media;
  unsigned int port;
  char *proto;
  char *fmt;
  int no_of_attrs;
  struct lent *attr;
  struct media *next;
};
