#include "sdr.h"
#include "sdr_server.h"
#include "server_prototypes.h"
#include "server_scope.h"

char NEW_FORM1[] = "\
<FORM ACTION=/create/new METHOD=post>\n\
<B>Session Name:</B>\n\
<INPUT TYPE=text NAME=sname SIZE=40>\n\
<br>\n\
<B>Description:</B>\n\
<br>\n\
<TEXTAREA NAME=desc ROWS=4 COLS=73>\n\
</TEXTAREA>\n\
<br>\n\
<B>URI:</B>\n\
<INPUT TYPE=text NAME=uri SIZE=70>\n\
<hr>\n\
<B>Scope</B> (how far the conference will reach)\n\
<SELECT NAME=scope SIZE=1>\n";

char NEW_FORM2[]="\
</SELECT>\n\
<hr>\n\
<B>Media to be used:</b>\n\
<br>\n\
<TABLE BORDER=0>\n\
<TH><img src=/images/audio> Audio</TH>\n\
<TH><img src=/images/video> Video</TH>\n\
<TH><img src=/images/whiteboard> Whiteboard</TH>\n\
<TH><img src=/images/text> Text</TH>\n\
<TR>\n\
<TD><SELECT NAME=audio SIZE=1>\n\
<OPTION>---\n\
<OPTION SELECTED>PCM\n\
<OPTION>DVI\n\
<OPTION>GSM\n\
<OPTION>LPC\n\
</SELECT>\n\
</TD>\n\
<TD>\n\
<SELECT NAME=video SIZE=1>\n\
<OPTION SELECTED>---\n\
<OPTION>H261\n\
<OPTION>nv\n\
</SELECT>\n\
</TD>\n\
<TD>\n\
<SELECT NAME=whiteboard SIZE=1>\n\
<OPTION>---\n\
<OPTION>wb\n\
<OPTION>nt\n\
</SELECT>\n\
</TD>\n\
<TD>\n\
<SELECT NAME=text SIZE=1>\n\
<OPTION SELECTED>---\n\
<OPTION>mumble\n\
</SELECT>\n\
</TD>\n\
</TR>\n\
</TABLE>\n\
<hr>\n\
<B>Session will be active:</B>\n\
<br>\n\
<SELECT NAME=rptmode>\n\
<OPTION SELECTED>Once\n\
<OPTION>Daily\n\
<OPTION>Weekly\n\
<OPTION>Every two Weeks\n\
</SELECT>\n\
<br>\n\
<TABLE>\n\
<TR>\n\
<TD></TD><TD ALIGN=center>DD</TD><TD>MM</TD><TD>YY</TD>\n\
<TR>\n\
<TD>From: </TD>\n\
<TD><INPUT TYPE=text NAME=sday SIZE=2 VALUE=%s></TD>\n\
<TD><INPUT TYPE=text NAME=smon SIZE=2 VALUE=%s></TD>\n\
<TD><INPUT TYPE=text NAME=syear SIZE=2 VALUE=%s></TD>\n\
<TD> at \n\
<SELECT NAME=stime>\n\
<OPTION>01:00\n\
<OPTION>01:30\n\
<OPTION>02:00\n\
<OPTION>02:30\n\
<OPTION>03:00\n\
<OPTION>03:30\n\
<OPTION>04:00\n\
<OPTION>04:30\n\
<OPTION>05:00\n\
<OPTION>05:30\n\
<OPTION>06:00\n\
<OPTION>06:30\n\
<OPTION>07:00\n\
<OPTION>07:30\n\
<OPTION>08:00\n\
<OPTION>08:30\n\
<OPTION>09:00\n\
<OPTION>09:30\n\
<OPTION>10:00\n\
<OPTION>10:30\n\
<OPTION>11:00\n\
<OPTION>11:30\n\
<OPTION>12:00\n\
<OPTION>12:30\n\
</SELECT>\n\
<SELECT NAME=sdn>\n\
<OPTION>am\n\
<OPTION>pm\n\
</SELECT>\n\
for\n\
<SELECT NAME=duration>\n\
<OPTION>1\n\
<OPTION>2\n\
<OPTION>3\n\
<OPTION>4\n\
<OPTION>5\n\
<OPTION>6\n\
<OPTION>7\n\
<OPTION>8\n\
<OPTION>9\n\
<OPTION>10\n\
<OPTION>11\n\
<OPTION>12\n\
<OPTION>13\n\
<OPTION>14\n\
</SELECT>\n\
<SELECT NAME=dunits>\n\
<OPTION>hours\n\
<OPTION>days\n\
</SELECT>\n\
</TR>\n\
</TABLE>\n\
<br>\n\
Repeated for:\n\
<SELECT NAME=rptfor>\n\
<OPTION SELECTED>0\n\
<OPTION>2\n\
<OPTION>3\n\
<OPTION>4\n\
<OPTION>5\n\
<OPTION>6\n\
<OPTION>7\n\
<OPTION>8\n\
<OPTION>9\n\
<OPTION>10\n\
<OPTION>11\n\
<OPTION>12\n\
<OPTION>12\n\
<OPTION>14\n\
</SELECT>\n\
<SELECT NAME=rptunits>\n\
<OPTION SELECTED>days\n\
<OPTION> weeks\n\
</SELECT>\n\
<hr>\n\
<B>Person to contact about this session</B>:\n\
<TABLE BORDER=0>\n\
<TR><TD>Name:</TD><TD><INPUT TYPE=text NAME=name SIZE=30></TD>\n\
<TD>Phone</TD><TD><INPUT TYPE=text NAME=phone SIZE=30></TD>\n\
<TR><TD></TD><TD></TD><TD>Email</TD>\n\
<TD><INPUT TYPE=text NAME=email SIZE=30></TD>\n\
</TABLE>\n\
\n\
<hr>\n\
<INPUT TYPE=submit VALUE=Submit>\n\
<INPUT TYPE=reset VALUE=Reset>\n\
</FORM>\n\
";

int create_form(char *str, hash_t aid)
{
  struct timeval tv;
  struct tm *tms;
  struct scope *scope;
  
  if(aid==0)
    {
      char day[3], mon[3], year[3];
#ifdef SYSV    
      gettimeofday(&tv);
#else
      gettimeofday(&tv, NULL);
#endif
      tms=localtime((time_t*)&tv);
      strftime(day, 3, "%d", tms);
      strftime(mon, 3, "%m", tms);
      strftime(year, 3, "%y", tms);
      sprintf(str, NEW_FORM1);
      str+=strlen(str);
      scope=get_first_scope();
      while(scope!=NULL)
	{
	  sprintf(str, "<OPTION>%s\n", scope->name);
	  str+=strlen(str);
	  scope=get_next_scope(scope);
	}
      sprintf(str, NEW_FORM2, day, mon, year);
      str+=strlen(str);
    }
  return 0;
}
