#include "generic_prototypes.h"

#ifdef SYSV
/*byte_fns.c*/
void bcopy(char *s1, char *s2, int len);
void bzero(char *str, int len);
#endif

/*sdr_server.c*/
int sd_listen(char *address, int port, int *rxsock, int *no_of_socks);
void recv_packets();
void recv_local_packets();
int timed_send_advert(ClientData cd);
int send_advert(char *adstr, int sock, unsigned char ttl);
int queue_ad_for_sending(char *aid, char *adstr, int interval, long end_time, char * address, int port, unsigned char ttl);
int stop_session_ad(char *aid);
void clean_up_and_die();
void force_numeric(char *str);
void splat_tcl_special_chars(char *str);
void warn_tcl_special_chars(char *str);
unsigned long parse_entry(hash_t *advertid, char *data, int length);
int check_net_type(char *in, char *ip);
void parse_local_advert(struct lsdap_advert *buf, int length);
void parse_local_hashlist(struct lsdap_hashlist *buf, int length, 
			  unsigned long src);
void parse_local_hashreq(struct lsdap_hashreq *buf, int length);
void send_local_advert(u_int aid, u_int origin, char *buf, int txsock, int length);
void send_hash_list(int txsock);
void save_cache();
void send_hash_request(u_int aid, int txsock);
unsigned long ntptounix(unsigned long ntp);
unsigned long unix_to_ntp(unsigned long time);
void nextline(char **ad);
int html_print_session_name(char *str, hash_t aid);
int html_print_session_summary(char *str, hash_t aid);
int html_print_session_details(char *str, hash_t aid);

/*store_addresses.c*/
void store_entry(struct session *sess, char *buf, int length, struct entry_list *elist, u_char origin, struct scope *scope);
void timeout_stored_entries(struct entry_list *elist);
hash_t *create_hash_list(int *length, struct entry_list *elist);
void free_hash_list(hash_t *hashlist);
char *get_stored_entry(hash_t aid, struct entry_list *elist, int *length);
struct session *get_stored_session(hash_t aid, struct entry_list *elist);
int have_entry(hash_t aid, struct entry_list *elist);
void sort_hash_list(hash_t *hashlist, int length, int order);
unsigned int get_origin(hash_t aid, struct entry_list *elist);
struct scope *get_scope(hash_t aid, struct entry_list *elist);
void init_entry_list(struct entry_list *elist);

/*server_http*/
int http_init();
void http_closedown();
int http_accept();
void http_fd_set(fd_set *fdset);
void http_fd_isset(fd_set *fdset);

/*server_html*/
int html_print_session(struct session *sess, char *str);

/*server_form.c*/
int create_form(char *str, hash_t aid);

/*server_parser*/
struct session *parse_session(char *ad);
void free_session(struct session *s);
void init_sess(struct session *sess);
char *storethisline(char *str);

/*generate_ids*/
/*generate_ids*/
int generate_port(char *s);
int store_address(struct in_addr *addr, unsigned long endtime);
struct in_addr generate_address();

/*server scope*/
struct scope *lookup_scope(char *name);

/*server init*/
int server_init(char *configfile);
void inithtmlmap();

/*server send*/
void add_to_send_queue(hash_t aid, unsigned long endtime, unsigned long timeout, struct scope *scope, struct send_queue *rq);
