set invited_sessions {}
set qdurs {"5 mins" "15 mins" "half hour" "an hour"}
set qdurt {300 900 1800 3600}
#set qpurp {"Two-way call" "Group Chat" "Small Meeting" "Large Meeting"}
set qpurp {"Group Chat" "Small Meeting" "Large Meeting"}
#set qpmway {0 1 1 1}
set qpmway {1 1 1}
proc qcall {} {
    global scope qdurs qdurt qpurp qpmway medialist send
    catch {destroy .qc}
    toplevel .qc
    wm title .qc "Sdr: Quick Call"
    posn_win .qc
    frame .qc.f -borderwidth 2 -relief groove
    pack .qc.f -side top
    new_mk_session_name .qc.f new
    set scope admin
    frame .qc.f.l -borderwidth 0
    pack .qc.f.l -side left -anchor nw
    label .qc.f.l.l -text "Expected Duration:  "
    pack .qc.f.l.l -side top
    menubutton .qc.f.l.m -menu .qc.f.l.m.menu -text [lindex $qdurs 0] -relief raised -borderwidth 1

    tixAddBalloon .qc.f.l.m MenuButton [tt "Select how long your quick \
call is likely to last. \n\nThis is the time that the quick call \
will be advertised in the main session window under private \
sessions - the session announcement will only be available to \
people you invite to join the session"]

    global qdur
    set qdur [lindex $qdurt 0]
    pack .qc.f.l.m -side top
    menu .qc.f.l.m.menu -tearoff 0
    for {set i 0} {$i < [llength $qdurs]} {incr i} {
	.qc.f.l.m.menu add radiobutton -label [lindex $qdurs $i] \
	    -variable qdur -value [lindex $qdurt $i] \
	    -command ".qc.f.l.m configure -text \"[lindex $qdurs $i]\""
    }
    label .qc.f.l.l2 -text "Purpose:"
    pack .qc.f.l.l2 -side top
    menubutton .qc.f.l.m2 -menu .qc.f.l.m2.menu -text [lindex $qpurp 0] -relief raised -borderwidth 1
    tixAddBalloon .qc.f.l.m2 MenuButton [tt "Select the purpose of the quick call. This will be given to the people you invite to partake in the quick call"]
    global qpur
    set qpur [lindex $qpurp 0]
    pack .qc.f.l.m2 -side top
    menu .qc.f.l.m2.menu -tearoff 0
    for {set i 0} {$i < [llength $qpurp]} {incr i} {
	.qc.f.l.m2.menu add radiobutton -label [lindex $qpurp $i] \
	    -variable qpur -value [lindex $qpurp $i] \
	    -command ".qc.f.l.m2 configure -text \"[lindex $qpurp $i]\";qset_config_scope \$qpur"
    }
    frame .qc.f.l.f -borderwidth 0
    pack .qc.f.l.f -side top
    new_mk_session_admin .qc.f.l.f.admin new $scope
    qset_config_scope $qpur
    foreach i $medialist {
	set send($i) 0
    }
    set send(audio) 1
    new_mk_session_media .qc.f.media new admin 0
    frame .qc.f.buttons -borderwidth 2 -relief groove
    pack .qc.f.buttons -side top -fill x -expand true
    button .qc.f.buttons.invite -text "Invite" -command {set invaid [qcreate];if {$invaid!=0} { popup $invaid $ifstyle(view) advert;embed_invite $invaid .desc$invaid.f;destroy .qc}}
    tixAddBalloon .qc.f.buttons.invite Button [tt "Click here to invite people to participate in the session"]
    pack .qc.f.buttons.invite -side left -fill x -expand true
    button .qc.f.buttons.dismiss -text "Cancel" -command {destroy .qc}
    tixAddBalloon .qc.f.buttons.dismiss Button [tt "Click here to cancel creating a quick call"]
    pack .qc.f.buttons.dismiss -side left -fill x -expand true
    move_onscreen .qc
}


proc qset_config_scope {purpose} {
    if {$purpose=="Two-way call"} {
	pack unpack .qc.f.l.f.admin
    } else {
	pack .qc.f.l.f.admin  -side top
    }
}

set qseq 0
proc qcreate {} {
    #create a session that we don't publically announce to anyone
    #so we can do a private invitation
    global qseq qpur qdur zone ttl media_attr media_fmt media_proto
    global yourphone youremail medialist send ldata sesstype
    global sdrversion
    set aid priv$qseq
    incr qseq
    if {[get_new_session_name .qc.f]==""} {
        errorpopup "No Session Name" "You must give the session a name"
        return 0
    }
    set ldata($aid,session) [get_new_session_name .qc.f]
    set ldata($aid,desc) $qpur
    set ldata($aid,phonelist) \"$yourphone\"
    set ldata($aid,emaillist) \"$youremail\"
    set ldata($aid,starttime) [unix_to_ntp [gettimeofday]]
    set ldata($aid,endtime) [unix_to_ntp [expr [gettimeofday] + $qdur]]
    set ldata($aid,no_of_times) 1
    set ldata($aid,time0,no_of_rpts) 0
    set ldata($aid,starttime,0) [unix_to_ntp [gettimeofday]]
    set ldata($aid,endtime,0) [unix_to_ntp [expr [gettimeofday] + $qdur]]
    set ldata($aid,method) invite
    set ldata($aid,type) meeting
    set ldata($aid,tool) "sdr $sdrversion"
    set ldata($aid,vars) "tool:$ldata($aid,tool)\ntype:$ldata($aid,type)"
    set medianum 0
    foreach media $medialist {
        if {$send($media)==1} {
	    set ldata($aid,$medianum,media) $media
	    set ldata($aid,$medianum,port) [generate_port $media]
	    set ldata($aid,$medianum,addr) [generate_address $zone(base_addr,$zone(cur_zone)) $zone(netmask,$zone(cur_zone))]
	    set ldata($aid,$medianum,fmt) $media_fmt($media)
	    set ldata($aid,$medianum,proto) $media_proto($media)
	    set ldata($aid,$medianum,ttl) $zone(ttl,$zone(cur_zone))
	    set ldata($aid,$medianum,vars) ""
            foreach attr [array names media_attr] {
                set m [lindex [split $attr ","] 0]
                set a [lindex [split $attr ","] 1]
                if {$m==$media} {
                    if {$media_attr($attr)==1} {
			set ldata($aid,$medianum,vars) \
                        "$ldata($aid,$medianum,vars) $a"
		    } elseif {($media_attr($attr)!=0)&&\
			    ($media_attr($attr)!="")} {
			set ldata($aid,$medianum,vars) \
		           "$ldata($aid,$medianum,vars) $a:$media_attr($attr)"
		    }
                }
            }
	    incr medianum
        }
    }
    if {$medianum==0} {
	errorpopup "No Media Selected" "You must select at least one media"
	return 0
    }
    set ldata($aid,medianum) $medianum
    set ldata($aid,creator) [getusername]
    set ldata($aid,createtime) [gettimeofday]
    set ldata($aid,modtime) [gettimeofday]
    set ldata($aid,createaddr) [gethostaddr]
    set ldata($aid,uri) 0
    set ldata($aid,multicast) $ldata($aid,0,addr)
    set ldata($aid,ttl) $ldata($aid,0,ttl)
    set ldata($aid,tfrom) [fixtime [gettime \
                                    [ntp_to_unix $ldata($aid,starttime)]]]
    set ldata($aid,tfrom,0) $ldata($aid,tfrom)
    set ldata($aid,tto) [fixtime [gettime \
                                  [ntp_to_unix $ldata($aid,endtime)]]]
    set ldata($aid,tto,0) $ldata($aid,tto)
    set ldata($aid,source) $ldata($aid,createaddr)
    set ldata($aid,heardfrom) "local user"
    set ldata($aid,theard) [fixtime [gettime [gettimeofday]]]
    return $aid
}

proc invite {aid} {
    global invited_sessions ldata
    catch {destroy .inv}
    toplevel .inv
#    puts "C aid:$aid"
    wm title .inv "Sdr: Invite User"
    if {$invited_sessions=={}} {
	set invited_sessions $aid
    } else {
	if {[lsearch $invited_sessions $aid]==-1} {
	    set invited_sessions "$invited_sessions $aid"
	}
    }
    foreach session $invited_sessions {
	set wname .inv.$session
	frame $wname -borderwidth 2 -relief groove
	pack $wname -side top
	label $wname.l -text $ldata($session,session)
	pack $wname.l -side top
	frame $wname.f
	pack $wname.f -side top -fill x -expand true
	entry $wname.f.e -width 30 -relief sunken \
	    -bg [option get . entryBackground Sdr]
	bind $wname.f.e <Return> "send_sip \[$wname.f.e get\] \"$session\" 0"
	pack $wname.f.e -side left -fill x -expand true
	button $wname.f.inv -text "Invite" -command "send_sip \[$wname.f.e get\] \"$session\" 0"
	pack $wname.f.inv -side left
	sip_list_invitees $wname $session
    }
    frame .inv.f -borderwidth 2 -relief groove
    pack .inv.f -side top -fill x -expand true
    button .inv.f.dismiss -text "Dismiss" -command "destroy .inv"
    pack .inv.f.dismiss -side left -fill x -expand true
}

proc embed_invite {aid win} {
    global invited_sessions ldata
    frame $win.inv
    pack $win.inv -side top -before $win.f3  -fill x -expand true
    if {$invited_sessions=={}} {
	set invited_sessions $aid
    } else {
	if {[lsearch $invited_sessions $aid]==-1} {
	    set invited_sessions "$invited_sessions $aid"
	}
    }
    set session $aid
#    foreach session $invited_sessions {
	set wname $win.inv.$session
	frame $wname -borderwidth 2 -relief groove
	pack $wname -side top
	label $wname.l -text "Invite user: (username@hostname)"
	pack $wname.l -side top -anchor nw
	frame $wname.f
	pack $wname.f -side top -fill x -expand true
	entry $wname.f.e -width 30 -relief sunken \
	    -bg [option get . entryBackground Sdr]
	tixAddBalloon $wname.f.e Entry [tt "Enter username and machinename for user in the form: username@machine"]
	bind $wname.f.e <Return> "send_sip \[$wname.f.e get\] \"$session\" 0 $wname"
	pack $wname.f.e -side left -fill x -expand true
	button $wname.f.inv -text "Invite" -command "send_sip \[$wname.f.e get\] \"$session\" 0 $wname"
	pack $wname.f.inv -side left
	sip_list_invitees $wname $session
#    }
    catch {pack unpack $win.f3.invite}
#    frame $win.inv.f -borderwidth 2 -relief groove
#    pack $win.inv.f -side top -fill x -expand true
#    button $win.inv.f.dismiss -text "Dismiss" -command "destroy $win.inv"
#    pack $win.inv.f.dismiss -side left -fill x -expand true
}

proc sip_list_invitees {wname aid} {
    global sip_request_status sip_requests sip_request_user sip_request_aid
    foreach id $sip_requests {
	if {$sip_request_aid($id)==$aid} {
	    set lid [join [split $id "."] "-"]
	    if {$sip_request_status($id)!="declined"} {
		frame $wname.$lid
		pack $wname.$lid -side top
		label $wname.$lid.l1 -width 20 -text $sip_request_user($id)
		pack $wname.$lid.l1 -side left
		label $wname.$lid.l2 -width 10 -text $sip_request_status($id)
		pack $wname.$lid.l2 -side left
	    }
	}
    }
}

proc send_sip {user aid id win} {
    global youremail no_of_connections sip_request_status sip_requests
    global sip_request_count sip_request_user
    set username [string trimleft [lindex [split $user "@"] 0] " "]
    set host [string trimright [lindex [split $user "@"] 1] " "]
    if {($username=="")||($host=="")} {
	msgpopup "Invalid Address" "Addresses must be of the form \"username@host\""
	return 0
    }
    set addr [lookup_host $host]
    if {$addr=="0.0.0.0"} {
	msgpopup "Invalid Address" "The hostname $host is not known"
	return 0
    }

    if {[lsearch $sip_requests $id]!=-1} {
	if {($sip_request_status($id)=="unknown") &&
	    ($sip_request_count($id)>10)} {
		sip_connection_fail $id "No response from remote site while trying to contact $sip_request_user($id)"
		return 0
	    }
	if {($sip_request_status($id)=="progressing") &&
	    ($sip_request_count($id)>20)} {
		sip_connection_fail $id "Unknown failure at remote site while trying to contact $sip_request_user($id)"
		return 0
	    }
	if {($sip_request_status($id)=="ringing") &&
	    ($sip_request_count($id)>30)} {
		sip_connection_fail $id "No response from $sip_request_user($id) to ringing at remote site"
		return 0
	    }
	if {($sip_request_status($id)=="connected")||
	    ($sip_request_status($id)=="declined")} {
		return 0
	    }
	incr sip_request_count($id)
    }
    if {$id==0} {
	set id "[gethostaddr]/[gettimeofday]"
	set sip_request_count($id) 0
    }
    set msg "SIP/1.0 REQ"
    set msg "$msg\nPA=[gethostaddr]"
    set msg "$msg\nAU=none"
    set msg "$msg\nID=$id"
    set msg "$msg\nFR=$youremail"
    set msg "$msg\nTO=$user"
    set msg "$msg\n[make_session $aid]"
#    puts $msg
    if {[sip_user_pending $user $id $aid $win]==0} {
	if {[sip_send_msg $msg $addr]==0} {
	    set no_of_connections($id) 1
	    after 2000 send_sip $user $aid $id $win
	} else {
	    sip_connection_fail $id "No-one is listening to invitations sent to $sip_request_user($id)"
	}
    }
    return 0
}

set sip_requests {}
proc sip_user_pending {user id aid win} {
    global sip_request_status sip_requests sip_request_user sip_request_aid
    global sip_request_win
#    puts $id
    if {[lsearch $sip_requests $id]!=-1} {
	return 0
    }
    foreach eid $sip_requests {
	if {$sip_request_user($eid)==$user} {
	    if {($sip_request_status($eid)=="unknown")||
		($sip_request_status($eid)=="progressing")||
		($sip_request_status($eid)=="ringing")} {
		    msgpopup "Call in progress" "You are already calling $user"
		    return -1
		}
	}
    }
    set sip_request_status($id) unknown
    set sip_request_user($id) $user
    set sip_request_aid($id) $aid
    set sip_request_win($id) $win
    set sip_requests "$sip_requests $id"
    set lid [join [split $id "."] "-"]
#    set f .inv.$aid.$lid
    set f $win.$lid
    frame $f
    pack $f -after $win.f
    label $f.l1 -text $user -width 20
    pack $f.l1 -side left
    label $f.l2 -text "?" -width 10
    pack $f.l2 -side left
    return 0
}

proc sip_session_status {id status} {
    global sip_request_status sip_requests sip_request_aid
    global sip_request_win
    if {[lsearch $sip_requests $id]==-1} {
        return 0
    }
    set sip_request_status($id) $status
    set lid [join [split $id "."] "-"]
#    set aid $sip_request_aid($id)
    set f $sip_request_win($id).$lid
    catch {$f.l2 configure -text $status}
}

set sip_invites {}
proc sip_user_alert {msg} {
    global sip_invites sip_invite_status
    set lines [split $msg "\n"]
    foreach line $lines {
	set lparts [split $line "="]
	switch [lindex $lparts 0] {
	    FR {
		set srcuser [join [lrange $lparts 1 end] "="]
	    }
	    TO {
		set dstuser [join [lrange $lparts 1 end] "="]
	    }
	    ID {
		set id [join [lrange $lparts 1 end] "="]
	    }
	    PA {
		set path [join [lrange $lparts 1 end] "="]
	    }
	    s {
		set sname [join [lrange $lparts 1 end] "="]
	    }
	}
    }
#    puts here
    if {[lsearch $sip_invites $id]==-1} {
	#it's a new invite
	set sip_invites "$sip_invites $id"
	sip_inform_user $id $srcuser $dstuser $path $sname $msg
	set sip_invite_status($id) ringing
	sip_ringing_user $id $srcuser $dstuser $path
    } else {
	switch $sip_invite_status($id) {
	    ringing {
		sip_ringing_user $id $srcuser $dstuser $path
	    }
	    refused {
		sip_refuse_invite $id $srcuser $dstuser $path
	    }
	    accepted {
		sip_accept_invite $id $srcuser $dstuser $path
	    }
	}
    }
}

proc sip_inform_user {id srcuser dstuser path sname sdp} {
    global ifstyle
    global sessdetails
#    set win .alert[join [split $id "."] "-"]
#    catch {destroy $win} 
#    toplevel $win
#    wm title $win "Sdr: Incoming call from $srcuser"
#    frame $win.f -borderwidth 2 -relief groove
#    pack $win.f -side top
#    label $win.f.l -text "Incoming call"
#    pack $win.f.l -side top
#    message $win.f.m -aspect 500 -text "User $srcuser is inviting you to join a session called $sname"
#    pack $win.f.m -side top
#    frame $win.f.f 
#    pack $win.f.f -side top -fill x
#    button $win.f.f.yes -text "Accept Invitation" -command "sip_accept_invite $id $srcuser $dstuser $path \"[escape_quotes $sdp]\";popup [parse_sdp $sdp] $ifstyle(view) $srcuser;destroy $win"
#    pack $win.f.f.yes -side left -fill x
#    button $win.f.f.no -text "Refuse Invitation" -command "sip_refuse_invite $id $srcuser $dstuser $path;destroy $win"
#    pack $win.f.f.no -side left -fill x
    popup [set aid [parse_sdp $sdp]] $ifstyle(view) $srcuser
    set sessdetails($aid,id) $id
    set sessdetails($aid,srcuser) $srcuser
    set sessdetails($aid,dstuser) $dstuser
    set sessdetails($aid,path) $path
    set sessdetails($aid,sdp) $sdp
}

proc sip_ringing_user {id srcuser dstuser path} {
    set msg "SIP/1.0 REP 3 RINGING"
    set msg "$msg\nPA=$path"
    set msg "$msg\nAU=none"
    set msg "$msg\nID=$id"
    set msg "$msg\nFR=$srcuser"
    set msg "$msg\nTO=$dstuser"
    set msg "$msg\nCH=IN IP4 [gethostaddr]"
    sip_send_msg $msg [lrange $path end end]
    start_ringing
}

proc sip_accept_invite {aid} {
    global sessdetails
    sip_send_accept_invite \
	$sessdetails($aid,id) \
	$sessdetails($aid,srcuser) \
	$sessdetails($aid,dstuser) \
	$sessdetails($aid,path) \
	$sessdetails($aid,sdp)
    add_to_priv_list $aid
}

proc sip_refuse_invite {aid} {
    global sessdetails
    sip_send_refuse_invite \
	$sessdetails($aid,id) \
	$sessdetails($aid,srcuser) \
	$sessdetails($aid,dstuser) \
	$sessdetails($aid,path)
}

proc sip_send_accept_invite {id srcuser dstuser path sdp} {
    set msg "SIP/1.0 REP 1 SUCCESS"
    set msg "$msg\nPA=$path"
    set msg "$msg\nAU=none"
    set msg "$msg\nID=$id"
    set msg "$msg\nFR=$srcuser"
    set msg "$msg\nTO=$dstuser"
    set msg "$msg\nCH=IN IP4 [gethostaddr]"
    sip_send_msg $msg [lrange $path end end]
    stop_ringing
}

proc sip_send_refuse_invite {id srcuser dstuser path} {
    set msg "SIP/1.0 REP 2 DECLINE"
    set msg "$msg\nPA=$path"
    set msg "$msg\nAU=none"
    set msg "$msg\nID=$id"
    set msg "$msg\nFR=$srcuser"
    set msg "$msg\nTO=$dstuser"
    set msg "$msg\nCH=IN IP4 [gethostaddr]"
    sip_send_msg $msg [lrange $path end end]
    stop_ringing
}

proc sip_success {msg} {
    set lines [split $msg "\n"]
#    puts $msg
    foreach line $lines {
        set lparts [split $line "="]
        switch [lindex $lparts 0] {
            FR {
                set srcuser [join [lrange $lparts 1 end] "="]
            }
            TO {
                set dstuser [join [lrange $lparts 1 end] "="]
            }
            ID {
                set id [join [lrange $lparts 1 end] "="]
            }
            PA {
                set path [join [lrange $lparts 1 end] "="]
            }
            s {
                set sname [join [lrange $lparts 1 end] "="]
            }
        }
    }
    sip_connection_succeed $id "$dstuser accepts your invitation"
}

proc sip_status {msg} {
    set smode [lindex $msg 3]
    set lines [split $msg "\n"]
    foreach line $lines {
        set lparts [split $line "="]
        switch [lindex $lparts 0] {
            FR {
                set srcuser [join [lrange $lparts 1 end] "="]
            }
            TO {
                set dstuser [join [lrange $lparts 1 end] "="]
            }
            ID {
                set id [join [lrange $lparts 1 end] "="]
            }
            PA {
                set path [join [lrange $lparts 1 end] "="]
            }
            s {
                set sname [join [lrange $lparts 1 end] "="]
            }
        }
    }
    switch $smode {
	TRYING {
	    if {$path==[gethostaddr]} {
		#I sent this request
		sip_session_status $id progressing
	    }
	}
	RINGING {
	    if {$path==[gethostaddr]} {
		#I sent this request
		sip_session_status $id ringing
	    }
	}
    }
}
proc sip_failure {msg} {
    global no_of_connections
    set smode [lindex $msg 3]
    set lines [split $msg "\n"]
    foreach line $lines {
        set lparts [split $line "="]
        switch [lindex $lparts 0] {
            FR {
                set srcuser [join [lrange $lparts 1 end] "="]
            }
            TO {
                set dstuser [join [lrange $lparts 1 end] "="]
            }
            ID {
                set id [join [lrange $lparts 1 end] "="]
            }
            PA {
                set path [join [lrange $lparts 1 end] "="]
            }
            s {
                set sname [join [lrange $lparts 1 end] "="]
            }
        }
    }
    switch $smode {
	DECLINE {
	    sip_connection_fail $id "User $dstuser declined to join"
	    sip_cancel_connection $id all
	}
	BUSY {
	    sip_connection_fail $id "User $dstuser was busy"
	    sip_cancel_connection $id all
	}
	UNSUCCESSFUL {
	    if {no_of_connections($id)==1} {
		sip_connection_fail $id "User $dstname could not be contacted"
	    } else {
		sip_cancel_connection $id $path
	    }
	}
	UNKNOWN {
	    if {no_of_connections($id)==1} {
		sip_connection_fail $id "User $dstname was not known"
	    } else {
		sip_cancel_connection $id $path
	    }
	}
	FAILED {
	    if {no_of_connections($id)==1} {
		sip_connection_fail $id "User $dstname could not be contacted"
	    } else {
		sip_cancel_connection $id $path
	    }
	}
	FORBIDDEN {
	    if {no_of_connections($id)==1} {
		sip_connection_fail $id "Authorisation failure contacting $dstname"
	    } else {
		sip_cancel_connection $id $path
	    }
	}
    }
}

proc sip_connection_fail {id msg} {
    global sip_request_status sip_requests sip_request_win
    if {[lsearch $sip_requests $id]==-1} {
#        puts a
        return 0
    }
    msgpopup "Connection attempt unsuccessful" $msg
    set lid [join [split $id "."] "-"]
    set f $sip_request_win($id).$lid
    catch {pack forget $f}
    set sip_request_status($id) declined
}

proc sip_connection_succeed {id msg} {
    global sip_request_status sip_requests sip_request_win sip_request_aid
    if {[lsearch $sip_requests $id]==-1} {
#        puts a
        return 0
    }
    msgpopup "Connection attempt Successful" $msg
    set lid [join [split $id "."] "-"]
    set f $sip_request_win($id).$lid
    catch {$f.l2 configure -text "connected"}
    set sip_request_status($id) connected
    add_to_priv_list  $sip_request_aid($id)
}

proc sip_cancel_connection {id hostaddr} {
}

proc escape_quotes {msg} {
    return [join [split $msg "\""] "\\\""]
}

proc start_ringing {} {
    global ringing_bell
    if {$ringing_bell==1} {return 0}
    set ringing_bell 1
    phone_ringing
    after 10000 stop_ringing
}
proc stop_ringing {} {
    global ringing_bell
    set ringing_bell 0
}

set ringing_bell 0
proc phone_ringing {} {
    global ringing_bell
    if {$ringing_bell==0} {return 0}
    bell
    after 200 bell
    after 400 bell
    after 1500 phone_ringing
}
