int sd_listen(char *address, int port, int rx_sock[], int *no_of_socks) 
{    
    struct sockaddr_in name;
    struct ip_mreq imr;
    char *interface = NULL;
    char addr[16];
    unsigned int group, b0, b1, b2, b3;
    int i,one=1, zero=0;

    if (no_of_socks!=NULL)
      {
	for(i=0;i<*no_of_socks;i++)
	  if (strcmp(address, rx_sock_addr[i])==0) {return(*no_of_socks);}
      }
    else
      {
	no_of_socks=&zero;
      }

    strncpy(addr,address,16);
    b0=atoi(strtok(addr,"."));
    b1=atoi(strtok((char*)NULL,"."));
    b2=atoi(strtok((char*)NULL,"."));
    b3=atoi(strtok((char*)NULL,"."));

    group = (((((b0*256)+b1)*256)+b2)*256)+b3;
    if((rx_sock[*no_of_socks]=socket( AF_INET, SOCK_DGRAM, 0 )) < 0) {
        perror("socket");
        exit(1);
    }

    fcntl(rx_sock[*no_of_socks], F_SETFD, 1);

    imr.imr_multiaddr.s_addr = htonl(group);
    if (interface!=NULL) {
        imr.imr_interface.s_addr = inet_addr(interface);
    } else {
        imr.imr_interface.s_addr = htonl(INADDR_ANY);
    }
    imr.imr_interface.s_addr = htonl(imr.imr_interface.s_addr);

    if (setsockopt(rx_sock[*no_of_socks], IPPROTO_IP, IP_ADD_MEMBERSHIP,
        (char *)&imr, sizeof(struct ip_mreq)) < 0 ) {
        perror("setsockopt - IP_ADD_MEMBERSHIP");
        exit(1);
    }

        /*
         *      Use INADDR_ANY if your multicast port doesn't allow
         *      binding to a multicast address.
         *
         */

    name.sin_family = AF_INET;
#ifndef CANT_MCAST_BIND
    name.sin_addr.s_addr = htonl(group);
#else
    name.sin_addr.s_addr = INADDR_ANY;
#endif
    name.sin_port = htons(port);
    if (bind(rx_sock[*no_of_socks], (struct sockaddr *)&name, sizeof(name))) {
        perror("bind");
	fprintf(stderr, "Address: %x, Port: %d\n",
		group, port);
        exit(1);
    }
    setsockopt(rx_sock[*no_of_socks], SOL_SOCKET, SO_REUSEADDR,
               (char *)&one, sizeof(one));
    rx_sock_addr[*no_of_socks]=malloc(strlen(address)+1);
    strcpy(rx_sock_addr[*no_of_socks], address);
    rx_sock_port[*no_of_socks]=port;
#ifdef DEBUG
    printf("sock %d bound to %x %d (%s)\n",*no_of_socks,group,port,address);
#endif
    (*no_of_socks)++;
    return(*no_of_socks);
}

int sd_tx(char *address, int port, int *txsock, int *no_of_socks) 
{
    struct sockaddr_in name;
    char addr[16];
    unsigned int group, b0, b1, b2, b3;
    int i, one=1, zero=0;
    if (no_of_socks!=NULL)
      {
	for(i=0;i<*no_of_socks;i++)
	  if (strcmp(address, tx_sock_addr[i])==0) {return(*no_of_socks);}
	tx_sock_addr[*no_of_socks]=malloc(strlen(address)+1);
	strcpy(tx_sock_addr[*no_of_socks],address);
      }
    else
      {
	no_of_socks=&zero;
      }

    
    strncpy(addr,address,16);
 
    b0=atoi(strtok(addr,"."));
    b1=atoi(strtok((char*)NULL,"."));
    b2=atoi(strtok((char*)NULL,"."));
    b3=atoi(strtok((char*)NULL,"."));

    group = (((((b0*256)+b1)*256)+b2)*256)+b3;
    if((txsock[*no_of_socks]=socket( AF_INET, SOCK_DGRAM, 0 )) < 0) {
        perror("socket");
        exit(1);
    }

    fcntl(txsock[*no_of_socks], F_SETFD, 1);

    name.sin_family = AF_INET;
    name.sin_addr.s_addr = INADDR_ANY;
    name.sin_port = 0;
#ifdef NOTDEF
    if (bind(txsock[*no_of_socks], (struct sockaddr *)&name, sizeof(name))) {
        perror("bind");
        exit(1);
    }
#endif
    if (setsockopt(txsock[*no_of_socks], IPPROTO_IP, IP_MULTICAST_TTL, (char *)&ttl, 
		   sizeof(ttl))<0)
      {
	
	fprintf(stderr, "ttl: %d\n", ttl);
	perror("setsockopt ttl");
	exit(-1);
      }
    name.sin_family = AF_INET;
    name.sin_addr.s_addr = htonl(group);
    name.sin_port = htons(port);
    if (connect(txsock[*no_of_socks], (struct sockaddr *)&name, sizeof(struct sockaddr_in))<0)
      {
	perror("connect");
	fprintf(stderr, "Dest Address problem\n");
	exit(-1);
      }
    setsockopt(txsock[*no_of_socks], SOL_SOCKET, SO_REUSEADDR,
               (char *)&one, sizeof(one));
    (*no_of_socks)++;
    return(*no_of_socks);
}


